-- Copyright 2007 Gas Powered Games - All rights reserved
--
-- Author: Bobucles
--
-- Description:
--    Shield Resetting mod. This lowers the recharge time on the units worst hit by the mod: ACU's and units with mobile shields.
--        All units with mobile shields have their recharge time cut in third, along with the amount restored being cut in third.
--  BlackopsACU support included, but currently disabled.


--this function is called already in game. This gives us a hook to screw the 
--blueprint values for the units

do
    local oldModBlueprints = ModBlueprints

    function ModBlueprints(all_bps)
	    oldModBlueprints(all_bps)

        local TimeToRestore = .33333

      
        --loop through the blueprints and adjust as desired.
        for id,bp in all_bps.Unit do
           if bp.Categories then
              for ik,Category in bp.Categories do 
                 if Category == "MOBILE" then

                  if bp.Defense.Shield.ShieldRechargeTime then
                      bp.Defense.Shield.ShieldRechargeTime = bp.Defense.Shield.ShieldRechargeTime * TimeToRestore
                  end

                  if bp.Enhancements.Shield.ShieldRechargeTime then
                      bp.Enhancements.Shield.ShieldRechargeTime = bp.Enhancements.Shield.ShieldRechargeTime * TimeToRestore
                  end
                
                  if bp.Enhancements.ShieldGeneratorField.ShieldRechargeTime then
                      bp.Enhancements.ShieldGeneratorField.ShieldRechargeTime = bp.Enhancements.ShieldGeneratorField.ShieldRechargeTime * TimeToRestore
                  end

                  if bp.Enhancements.ShieldHeavy.ShieldRechargeTime then
                      bp.Enhancements.ShieldHeavy.ShieldRechargeTime = bp.Enhancements.ShieldHeavy.ShieldRechargeTime * TimeToRestore
                  end

-- BlackopsACU support. Currently disabled, as Blackops already has some pretty damn good ACU shields.
-- 1.2: Enabled modifications to BlackOPs ACUs, to keep them balanced with the 2.8 increased reset time.
--
                   if bp.Enhancements.EXShieldBattery.ShieldRechargeTime then
                       bp.Enhancements.EXShieldBattery.ShieldRechargeTime = bp.Enhancements.EXShieldBattery.ShieldRechargeTime * TimeToRestore
                   end

                   if bp.Enhancements.EXActiveShielding.ShieldRechargeTime then
                       bp.Enhancements.EXActiveShielding.ShieldRechargeTime  = bp.Enhancements.EXActiveShielding.ShieldRechargeTime * TimeToRestore
                   end

                   if bp.Enhancements.EXImprovedShieldBattery.ShieldRechargeTime then
                       bp.Enhancements.EXImprovedShieldBattery.ShieldRechargeTime = bp.Enhancements.EXImprovedShieldBattery.ShieldRechargeTime * TimeToRestore
                   end

                   if bp.Enhancements.EXShieldExpander.ShieldRechargeTime then
                       bp.Enhancements.EXShieldExpander.ShieldRechargeTime = bp.Enhancements.EXShieldExpander.ShieldRechargeTime * TimeToRestore
                   end
                end
              end
           end     
        end
    end

end




